#include "DLL.CH"
#include "common.ch"

PROCEDURE MAIN
LOCAL cFileTime
LOCAL cSystemTime
LOCAL cLocalTime

   ? cLocalTime :=  LocalTime()


     cFileTime   := FileTime( Date(),Time() )
   ? cSystemTime := FTToST(cFileTime , ,.T.)

   WAIT
RETURN


FUNCTION FileTime(dDate, cTime)
LOCAL cConvertTime, cFileTime:=Space(8)

  IF dDate==NIL .AND. cTime==NIL
    DllCall("Kernel32.dll",DLL_STDCALL,"GetSystemTimeAsFileTime", @cFileTime)
    RETURN cFileTime
  ENDIF

  /* Resolve missing variables */
  dDate:=IF(dDate=NIL,Date(),dDate)
  cTime:=IF(cTime=NIL,Time(),cTime)

  /* Convert Time */
  cConvertTime:=w2Bin(Year(dDate))+w2Bin(Month(dDate))+w2Bin(0)+w2Bin(Day(dDate))+;
                w2Bin(THours(cTime))+w2Bin(TMins(cTime))+w2Bin(TSecs(cTime))+w2Bin(0)

  IF DllCall("Kernel32.dll",DLL_STDCALL,"SystemTimeToFileTime", cConvertTime, @cFileTime)==0
    RETURN Space(8)
  ENDIF

RETURN cFileTime

FUNCTION THours(cTime)
  DEFAULT cTime TO Time()
RETURN Val(SubStr(cTime,1,2))

FUNCTION TMins(cTime)
  DEFAULT cTime TO Time()
RETURN Val(SubStr(cTime,4,2))

FUNCTION TSecs(cTime)
  DEFAULT cTime TO Time()
RETURN Val(SubStr(cTime,7,2))


FUNCTION FTtoST(cFileTime, lDay, lConvert)
LOCAL cConvertTime:=Space(16), cDate, dDate

  DEFAULT lDay TO .F., lConvert TO .T.

  /* Convert Time */
  IF DllCall("Kernel32.dll",DLL_STDCALL,"FileTimeToSystemTime", cFileTime, @cConvertTime)==0
    RETURN ""
  ENDIF
  IF lConvert==.F.
    RETURN cConvertTime
  ENDIF

  cDate:=Padl(LTrim(Str(Bin2w(SubStr(cConvertTime,1,2)))),4,"0")+;
         Padl(LTrim(Str(Bin2w(SubStr(cConvertTime,3,2)))),2,"0")+;
         Padl(LTrim(Str(Bin2w(SubStr(cConvertTime,7,2)))),2,"0")
  dDate:=StoD(cDate)
  cDate:=DtoC(dDate)

RETURN IF(lDay,CdoW(dDate)+" ","")+cDate+" "+;
   Padl(LTrim(Str(Bin2w(SubStr(cConvertTime, 9,2)))),2,"0")+":"+;
   Padl(LTrim(Str(Bin2w(SubStr(cConvertTime,11,2)))),2,"0")+":"+;
   Padl(LTrim(Str(Bin2w(SubStr(cConvertTime,13,2)))),2,"0")+":"+;
   Padl(LTrim(Str(Bin2w(SubStr(cConvertTime,15,2)))),2,"0")


FUNCTION LocalTime(lDay)
LOCAL cConvertTime:=space(16), cDate, dDate

  DEFAULT lDay TO .F.

  /* Get Local Time */
  DllCall("Kernel32.dll",DLL_STDCALL,"GetLocalTime", @cConvertTime)
  cDate:=Padl(LTrim(Str(Bin2w(SubStr(cConvertTime,1,2)))),4,"0")+;
         Padl(LTrim(Str(Bin2w(SubStr(cConvertTime,3,2)))),2,"0")+;
         Padl(LTrim(Str(Bin2w(SubStr(cConvertTime,7,2)))),2,"0")
  dDate:=StoD(cDate)
  cDate:=DtoC(dDate)

RETURN IF(lDay,CdoW(dDate)+" ","")+cDate+" "+;
   Padl(LTrim(Str(Bin2w(SubStr(cConvertTime, 9,2)))),2,"0")+":"+;
   Padl(LTrim(Str(Bin2w(SubStr(cConvertTime,11,2)))),2,"0")+":"+;
   Padl(LTrim(Str(Bin2w(SubStr(cConvertTime,13,2)))),2,"0")+":"+;
   Padl(LTrim(Str(Bin2w(SubStr(cConvertTime,15,2)))),2,"0")

*
*
*